//
//  Action.js
//  FindVideoContent
//
//  Created by Michael Fuller on 5/8/15.
//  Copyright (c) 2015 Michael Glen Fuller Jr. All rights reserved.
//

var Action = function() {};

Action.prototype = {
    
run: function(arguments) {
    // Here, you can run code that modifies the document and/or prepares
    // things to pass to your action's native code.
    
    var videoTags = document.getElementsByTagName("video"), videoTag, videoSrc = '', videos = [], others = [], sources, source;
    var i, j, mp4File = new RegExp(/^.*mp4$/i), m3u8File = new RegExp(/^.*m3u8$/i), mp4Type = new RegExp(/^video\/mp4.*$/i);
    
    if (videoTags && videoTags.length > 0) {
        for (i = 0; i < videoTags.length; i++) {
            videoTag = videoTags[i];
            if (videoTag.src) {
                videos.push({src: videoTag.src, type: 'playing'});
            }
            
            {
                sources = videoTag.getElementsByTagName("source");
                if (sources && sources.length > 0) {
                    for (j = 0; j < sources.length; j++) {
                        source = sources[j];
                        if (source.src) {
                            if  (
                                 (
                                    (
                                        source.type && (mp4Type.test(source.type))
                                    )
                                    ||
                                    mp4File.test(source.src)
                                    ||
                                    m3u8File.test(source.src)
                                 )
                                ) {
                                videos.push({src: source.src, type: source.type, verified: true});
                            } else {
                                others.push({src: source.src, type: source.type, verified: false});
                            }
                        }
                    }
                }
            }
        }
    }
    
    if (others.length > 0) {
        for (i = 0; i < others.length; i++) {
            videos.push(others[i]);
        }
    }
    
    arguments.completionFunction({ "videos" : videos});
},
    
finalize: function(arguments) {
    // This method is run after the native code completes.
    
    // We'll see if the native code has passed us a new background style,
    // and set it on the body.
    
    /*
     var newBackgroundColor = arguments["newBackgroundColor"]
     if (newBackgroundColor) {
     // We'll set document.body.style.background, to override any
     // existing background.
     document.body.style.background = newBackgroundColor
     } else {
     // If nothing's been returned to us, we'll set the background to
     // blue.
     document.body.style.background= "blue"
     }
     */
    
}
    
};

var ExtensionPreprocessingJS = new Action
