// yourShader.frag
precision highp float;

uniform sampler2D tex0;
uniform sampler2D tex1;

uniform bool loaded;
uniform highp float percent;

varying highp vec2 texCoord;

// Static variables
vec4 blackcolor = vec4(0.0,0.0,0.0,1.0);

void main(void) {
  if (loaded == false) {
    gl_FragColor = blackcolor;
  } else if (percent < -0.25) {
      gl_FragColor = texture2D(tex0, texCoord);
  } else {
      highp vec4 texColor0 = texture2D(tex0, texCoord);
      highp vec4 texColor1 = texture2D(tex1, texCoord);
      lowp float otherPercent = (1.0 - percent);
      gl_FragColor = vec4(
                          (texColor0.x * otherPercent) + (texColor1.x * percent),
                          (texColor0.y * otherPercent) + (texColor1.y * percent),
                          (texColor0.z * otherPercent) + (texColor1.z * percent),
                          1.0);
  }
}