// yourShader.frag
precision highp float;
uniform sampler2D tex0;
uniform bool selected;

varying highp vec2 realCoord;
varying highp vec2 texCoord;
varying lowp float texRate;
varying lowp float texRate2;

uniform lowp float rate;

vec4 alphacolor = vec4(0.7,0.7,0.7,0.9);
vec4 tintcolor = vec4(0.0,0.0,0.5,1.0);
vec4 clearcolor = vec4(0.0,0.0,0.0,0.0);

void main(void) {
    vec4 test;// = clearcolor;
    
    if (texCoord.x >= 0.0 && texCoord.x <= 1.0 && texCoord.y >= 0.0 && texCoord.y <= 1.0) {
        test = texture2D(tex0, vec2(texCoord.x, texCoord.y));
    } else {
        test = clearcolor;
    }
    
    if (selected && rate > 0.0 && realCoord.y >= 0.4 && realCoord.y <= 0.6) {
        if ((1.0 - realCoord.x) <= rate && realCoord.y >= 0.45 && realCoord.y <= 0.55) {
            test = tintcolor;
        } else {
            test += alphacolor;
        }
    }
    
    gl_FragColor = test;
}