// yourShader.frag
precision highp float;

uniform sampler2D SamplerY;
uniform sampler2D SamplerUV;

uniform mat3 colorConversionMatrix;
uniform lowp vec4 outOffsets;

varying mediump vec2 v_textureCoordinate;

uniform vec4 colorFilter;

vec4 clearcolor = vec4(0.0,0.0,0.0,0);

void main(void) {    
    if (v_textureCoordinate.x >= 0.0 && v_textureCoordinate.x <= 1.0 && v_textureCoordinate.y >= 0.0 && v_textureCoordinate.y <= 1.0) {
        vec2 updatedPoint = vec2(outOffsets.x + (v_textureCoordinate.x * outOffsets.y), outOffsets.z + (v_textureCoordinate.y * outOffsets.w));
        
        mediump vec3 yuv;
        lowp vec3 rgb;
        
        yuv.x = texture2D(SamplerY, updatedPoint).r - (0.0627451);
        yuv.yz = texture2D(SamplerUV, updatedPoint).rg - vec2(0.5, 0.5);
        
        rgb = colorConversionMatrix * yuv;
        
        gl_FragColor = vec4(rgb, 1) - colorFilter;
    } else {
        gl_FragColor = clearcolor;
    }
}