precision highp float;
// Common
attribute highp vec4 position;
attribute highp vec2 textureCoordinate;
uniform mat4 modelViewProjection;

varying highp vec2 v_textureCoordinate;

uniform ivec4 flips;
uniform lowp vec4 offsets;

uniform bool enabled;

void main(void) {
    
    if (!enabled) {
        v_textureCoordinate = vec2(-0.1,-0.1);
    } else {
    
        float cX = flips.z == 0 ? textureCoordinate.x : textureCoordinate.y;
        float cY = flips.z == 0 ? textureCoordinate.y : textureCoordinate.x;
        if (flips.x == 0) {
            cX = 1.0 - cX;
        }
        if (flips.y == 1) {
            cY = 1.0 - cY;
        }
        if (flips.w == 0) {
            cX = (cX * offsets.x) - offsets.z;
            cY = (cY * offsets.y) - offsets.w;
        }
        if (cX < -0.5) {
            cX = -0.5;
        } else if (cX > 1.5) {
            cX = 1.5;
        }
        if (cY < -0.5) {
            cY = -0.5;
        } else if (cY > 1.5) {
            cY = 1.5;
        }
        v_textureCoordinate = vec2(cX, cY);
    }
    // output the projected position
    gl_Position = modelViewProjection * position;
}