precision highp float;
attribute highp vec4 position;
attribute highp vec2 textureCoordinate;
uniform mat4 modelViewProjection;

uniform bool selected;
uniform lowp float rate;
uniform lowp vec2 uvPoint;

varying highp vec2 texCoord;
varying lowp float texRate;
varying lowp float texRate2;

void main(void) {

    texCoord.x = (uvPoint.x + ((1.0 - textureCoordinate.x) * 0.125));
    texCoord.y = uvPoint.y + (textureCoordinate.y * 0.125);
    
    if (selected && rate > 0.0) {
        texRate = (1.0 - textureCoordinate.y) / rate;
        texRate2 = (1.0 - textureCoordinate.y) / (rate - 0.1);
    } else {
        texRate = 0.0;
        texRate2 = 0.0;
    }
    
    // texRate = (selected && rate > 0.0) ? (1.0 - textureCoordinate.y) / rate : 0.0;
   
    // output the projected position
    gl_Position = modelViewProjection * position;
}