precision highp float;
attribute highp vec4 position;
attribute highp vec2 textureCoordinate;
uniform mat4 modelViewProjection;

uniform bool loaded;
uniform lowp vec4 offsets;
uniform ivec4 flips;

varying highp vec2 texCoord;

void main(void) {
    
    if (loaded == false) {
        texCoord.x = 1.1;
        texCoord.y = 1.1;
    } else {
        float cX = flips.z == 0 ? textureCoordinate.x : textureCoordinate.y;
        float cY = flips.z == 0 ? textureCoordinate.y : textureCoordinate.x;
        if (flips.x == 1) {
            cX = 1.0 - cX;
        }
        if (flips.y == 1) {
            cY = 1.0 - cY;
        }
        if (flips.w == 0) {
            cX = (cX * offsets.x) - offsets.z;
            cY = (cY * offsets.y) - offsets.w;
        }
        if (cX < -0.5) {
            cX = -0.5;
        } else if (cX > 1.5) {
            cX = 1.5;
        }
        if (cY < -0.5) {
            cY = -0.5;
        } else if (cY > 1.5) {
            cY = 1.5;
        }
        texCoord = vec2(cX, cY);
    }
    
    // output the projected position
    gl_Position = modelViewProjection * position;
}