precision highp float;
attribute highp vec4 position;
attribute highp vec2 textureCoordinate;
uniform mat4 modelViewProjection;

uniform bool loaded;
uniform bool selected;
uniform lowp float rate;
//uniform lowp vec2 offsets;
uniform lowp vec4 offsets;

varying highp vec2 realCoord;
varying highp vec2 texCoord;
varying lowp float texRate;
varying lowp float texRate2;

void main(void) {
    realCoord = textureCoordinate;
    if (loaded == false) {
        texCoord.x = 1.1;
        texCoord.y = 1.1;
    } else {
        float cX;
        float cY;
        
        //float xScaler = 1.0 / (1.0 - (offsets.x * 2.0));
        //cX = (textureCoordinate.x * xScaler) - (xScaler * offsets.x);
        //float yScaler = 1.0 / (1.0 - (offsets.y * 2.0));
        //cY = (textureCoordinate.y * yScaler) - (yScaler * offsets.y);
        
        //float xScaler = 1.0 / (1.0 - (offsets.x * 2.0));
        cX = ((1.0 - textureCoordinate.x) * offsets.x) - offsets.z;
        //float yScaler = 1.0 / (1.0 - (offsets.y * 2.0));
        cY = (textureCoordinate.y * offsets.y) - offsets.w;
        
        if (cX > 1.5) {
            cX = 1.5;
        } else if (cX < -0.5) {
            cX = -0.5;
        }
        if (cY > 1.5) {
            cY = 1.5;
        } else if (cY < -0.5) {
            cY = -0.5;
        }
        
        texCoord.x = cX;
        texCoord.y = cY;
        
        //texCoord.x = ((((offsets.x * 2.0) + 1.0) * (1.0 - textureCoordinate.x)) - offsets.x);
        //texCoord.y = (((offsets.y * 2.0) + 1.0) * textureCoordinate.y) - offsets.y;
    }
    
    if (selected && rate > 0.0) {
        texRate = (1.0 - textureCoordinate.y) / rate;
        texRate2 = (1.0 - textureCoordinate.y) / (rate - 0.1);
    } else {
        texRate = 0.0;
        texRate2 = 0.0;
    }
    // texRate = (selected && rate > 0.0) ? (1.0 - textureCoordinate.y) / rate : 0.0;
    
    // output the projected position
    gl_Position = modelViewProjection * position;
}