// yourShader.frag
precision highp float;
uniform bool selected;
uniform bool vertical;
uniform float alphaOverride;
uniform lowp vec3 rate;

uniform lowp float selectedRate;
varying lowp vec2 texCoord;

vec4 tintcolor = vec4(0.0,0.0,0.5,1.0);
vec4 clearcolor = vec4(0.0,0.0,0.0,0.0);

void main(void) {
    if (alphaOverride < 0.01) {
        gl_FragColor = clearcolor;
    } else {
        float foundRate = 1.0 - (vertical ? texCoord.y : texCoord.x);
        float otherRate = 1.0 - (vertical ? texCoord.x : texCoord.y);
        float otherOffset = otherRate > 0.8 || otherRate < 0.2 ? 0.02 : 0.01;
        vec4 col = (foundRate >= rate.y && foundRate <= rate.z && otherRate >= 0.3 && otherRate < 0.7) ? vec4(0.4, 0.4, 0.7, (alphaOverride > 0.6) ? 0.6 : alphaOverride) : vec4(0.2, 0.2, 0.2, (alphaOverride > 0.6) ? 0.6 : alphaOverride);
        if (foundRate >= rate.x - otherOffset && foundRate <= rate.x + otherOffset) {
            col.x = 0.8;
            col.y = 0.8;
            col.z = 0.8;
        } else if (selected && (foundRate <= selectedRate)) {
            col.x = 0.0;
            col.y = 0.0;
            col.z = 0.7;
        }
    gl_FragColor = col;
    }
}